; GUI #
;movelight.c
;This program demonstrates when to issue lighting and
;transformation commands to render a model with a light
;which is moved by a modeling transformation (rotate or
;translate).  The light position is reset after the modeling
;transformation is called.  The eye position does not change.

;A sphere is drawn using a grey material characteristic.
;A single light source illuminates the object.

;Interaction:  pressing the left or right mouse button alters
;the modeling transformation (x rotation) by 30 degrees.
;The scene is then redrawn with the light in a new position.
include win64a.inc
; --------------- 
Wwd equ 500
Wht equ 400

.code
WinMain	proc
local	msg:MSG

	xor	ebx,ebx
        mov	edi,offset szClassName
        mov	esi,IMAGE_BASE
        mov	ecx,offset FileName
	invoke	LoadCursorFromFile
        push	rax	;hIconSm
	push	rdi	;lpszClassName
	push	rbx	;lpszMenuName
	push	COLOR_WINDOWTEXT+1;hbrBackground
	push	rax	;hCursor
	push	rax        ;hIcon
	push	rsi	;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc;lpfnWndProc
	push	sizeof WNDCLASSEX;cbSize & style
    	invoke	RegisterClassEx,esp	;addr WNDCLASSEX
	
	push	rbx
	push	rsi	;rsi = 400000h
	shl	esi,9	;rsi = CW_USEDEFAULT
	push	rbx
	push	rbx
	push	Wht
	push	Wwd
	push	rsi
	push	rsi
	sub	esp,20h
    	invoke	CreateWindowEx,0,edi,edi,WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_VISIBLE
; 
    	lea	edi,msg
@@:	invoke	GetMessage,edi,0,0,0
        cmp	msg.wParam,VK_ESCAPE;user press 'Esc'?
	je	wmDESTROY
	invoke	DispatchMessage,edi
	jmp	@b
WinMain endp
WndProc	proc	hWin:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	ps:PAINTSTRUCT
local	resultq:QWORD

        xor	ebx,ebx
        mov	hWin,rcx

        cmp	edx,WM_CREATE
	je      wmCREATE
        cmp	edx,WM_SIZE
	je      wmSIZE
        cmp	edx,WM_PAINT
	je      wmPAINT
        cmp	edx,WM_DESTROY
	je      wmDESTROY     
        cmp	edx,WM_LBUTTONDOWN
	je	wmLBUTTONDOWN
        cmp	edx,WM_RBUTTONDOWN
	je	wmRBUTTONDOWN
default:leave
	jmp	NtdllDefWindowProc_
wmDESTROY::invoke wglMakeCurrent,0,0
	invoke	wglDeleteContext,hrc
	invoke	ReleaseDC,hWin,hDC
	invoke	RtlExitUserProcess,NULL
;-----------------------------------------
wmLBUTTONDOWN:add spin,30
	cmp	spin,360
	jb	wmPAINT
	and     spin,0
	jmp	wmPAINT
wmRBUTTONDOWN:sub spin,30
	jns	wmPAINT
	mov     spin, 360
wmPAINT:; No pending messages: draw the scene
;Display the scene---------------
	lea	edx,ps
        invoke  BeginPaint,hWin
;GLDisplay---------------------------------------
	invoke  glClear,GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT
	invoke  glPushMatrix

	movq	xmm3,rbx	
	movq	xmm2,constd5
	movq	xmm1,rbx	
	movq	xmm0,rbx	
	invoke  gluLookAt,,,,,rbx,rbx,rbx,constd1,rbx
	invoke  glPushMatrix
	fild    spin
	fstp    resultq
	movq	xmm3,rbx	
	movq	xmm2,rbx	
	movq	xmm1,constd1
	movq	xmm0,resultq
	invoke  glRotated
	mov	r8d,offset position
	invoke  glLightfv, GL_LIGHT0, GL_POSITION
	movq	xmm2,constd1_5
	movq	xmm1,rbx	
	movq	xmm0,rbx	
	invoke  glTranslated
	invoke  glDisable, GL_LIGHTING
	mov	eax,const1
	movd	xmm2,eax
	movd	xmm1,eax
	movd	xmm0,ebx	
	invoke  glColor3f
	movd	xmm0,constd0_1
	invoke  glutWireCube
	invoke  glEnable, GL_LIGHTING
	invoke  glPopMatrix

	movd	xmm1,constd0_85
	movd	xmm0,constd0_275
	invoke  glutSolidTorus,,,8,15
	invoke  glPopMatrix
	invoke  glFlush
;---------------------------------------
        invoke	SwapBuffers,hDC
	lea	edx,ps
	invoke  EndPaint,hWin
        jmp	wmBYE
wmSIZE:; --------------- Resize the scene
        movzx	ecx,r9w
	mov	edx,r9d
	shr	edx,16
	invoke	GLReshape
        jmp	wmBYE
wmCREATE:invoke	GetDC  ;  
	mov	hDC,rax
;    OpenGL ( OpenGL   )
        mov	edx,offset pfd
	invoke	ChoosePixelFormat,eax; 
	mov	r8d,offset pfd
	invoke	SetPixelFormat,hDC,eax;  
	invoke	wglCreateContext,hDC;     OpenGL
	mov	hrc,rax
	invoke	wglMakeCurrent,hDC,eax;   
;GLInit-----------------------------------------
	invoke  glShadeModel,GL_SMOOTH
	invoke  glEnable,GL_LIGHTING
	invoke  glEnable,GL_LIGHT0
	invoke  glEnable,GL_DEPTH_TEST
;------------------------------------------------	
	invoke	GLReshape,Wwd,Wht        
wmBYE:	leave
	xor	eax,eax
	retn	
WndProc	endp

GLReshape proc	w:dword, h:dword
local resultq:QWORD

	mov	w,ecx
	mov	h,edx

	fninit
	mov	r8d,ecx
	mov	r9d,edx
	invoke  glViewport,0,0
	invoke  glMatrixMode, GL_PROJECTION
	invoke  glLoadIdentity
	fild	w
	fidiv	h
	fstp    resultq
	movq	xmm3,constd20
	movq	xmm2,constd1
	movq	xmm1,resultq
	movq	xmm0,constd40
        invoke  gluPerspective
	invoke  glMatrixMode, GL_MODELVIEW
	invoke  glLoadIdentity
	leave
	retn
GLReshape endp
;-------------------------------------------------------
hDC	dq	?
hrc	dq	?
pfd	label	PIXELFORMATDESCRIPTOR 
;   
	nSize             dw	sizeof PIXELFORMATDESCRIPTOR
  	nVersion          dw	1;  
;  ,     
  	dwFlags           dd	PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or \
	PFD_DRAW_TO_WINDOW 
  	iPixelType        db	PFD_TYPE_RGBA; RGBA 
  	cColorBits        db	16;   
  	cRedBits          db	0
  	cRedShift         db	0
  	cGreenBits        db	0
  	cGreenShift       db	0
  	cBlueBits         db	0
  	cBlueShift        db	0;  
  	cAlphaBits        db	0;  
  	cAlphaShift       db	0;  
  	cAccumBits        db	0;  
  	cAccumRedBits     db	0
  	cAccumGreenBits   db	0
  	cAccumBlueBits    db	0
  	cAccumAlphaBits   db	0;  
  	cDepthBits        db	0;32  Z- ( )
  	cStencilBits      db	0;  
  	cAuxBuffers       db	0;  
  	iLayerType        db	PFD_MAIN_PLANE;  
  	bReserved         db	0;
  	dwLayerMask       dd	0
  	dwVisibleMask     dd	0
  	dwDamageMask      dd	0;  

spin		dd 0
position	dd 0.0, 0.0, 1.5, 1.0
const1		dd 1.0
constd0_1	dq 0.1
constd0_275	dq 0.275
constd0_85	dq 0.85
constd1		dq 1.0
constd1_5	dq 1.5
constd5		dq 5.0
constd20	dq 20.0
constd40	dq 40.0
szClassName	db "OpenGL - Move Light",0
FileName	db "br_Rabbit3.cur",0
end